/***************************************************************************
 *   Copyright (C) 2004 by Andr Stein                                     *
 *   stone@steinsoft.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 #include "sglslextension.h"
 
/** init function pointers **/

PFNGLVERTEXATTRIB1FARBPROC pglVertexAttrib1fARB = NULL;
PFNGLVERTEXATTRIB1SARBPROC pglVertexAttrib1sARB = NULL;
PFNGLVERTEXATTRIB1DARBPROC pglVertexAttrib1dARB = NULL;
PFNGLVERTEXATTRIB2FARBPROC pglVertexAttrib2fARB = NULL;
PFNGLVERTEXATTRIB2SARBPROC pglVertexAttrib2sARB = NULL;
PFNGLVERTEXATTRIB2DARBPROC pglVertexAttrib2dARB = NULL;
PFNGLVERTEXATTRIB3FARBPROC pglVertexAttrib3fARB = NULL;
PFNGLVERTEXATTRIB3SARBPROC pglVertexAttrib3sARB = NULL;
PFNGLVERTEXATTRIB3FARBPROC pglVertexAttrib3dARB = NULL;
PFNGLVERTEXATTRIB4FARBPROC pglVertexAttrib4fARB = NULL;
PFNGLVERTEXATTRIB4SARBPROC pglVertexAttrib4sARB = NULL;
PFNGLVERTEXATTRIB4DARBPROC pglVertexAttrib4dARB = NULL;
PFNGLVERTEXATTRIB4NUBARBPROC pglVertexAttrib4NubARB = NULL;

PFNGLVERTEXATTRIB1FVARBPROC pglVertexAttrib1fvARB = NULL;
PFNGLVERTEXATTRIB1SVARBPROC pglVertexAttrib1svARB = NULL;
PFNGLVERTEXATTRIB1DVARBPROC pglVertexAttrib1dvARB = NULL;
PFNGLVERTEXATTRIB2FVARBPROC pglVertexAttrib2fvARB = NULL;
PFNGLVERTEXATTRIB2SVARBPROC pglVertexAttrib2svARB = NULL;
PFNGLVERTEXATTRIB2DVARBPROC pglVertexAttrib2dvARB = NULL;
PFNGLVERTEXATTRIB3FVARBPROC pglVertexAttrib3fvARB = NULL;
PFNGLVERTEXATTRIB3SVARBPROC pglVertexAttrib3svARB = NULL;
PFNGLVERTEXATTRIB3DVARBPROC pglVertexAttrib3dvARB = NULL;
PFNGLVERTEXATTRIB4FVARBPROC pglVertexAttrib4fvARB = NULL;
PFNGLVERTEXATTRIB4SVARBPROC pglVertexAttrib4svARB = NULL;
PFNGLVERTEXATTRIB4DVARBPROC pglVertexAttrib4dvARB = NULL;
PFNGLVERTEXATTRIB4IVARBPROC pglVertexAttrib4ivARB = NULL;
PFNGLVERTEXATTRIB4BVARBPROC pglVertexAttrib4bvARB = NULL;
PFNGLVERTEXATTRIB4UBVARBPROC pglVertexAttrib4ubvARB = NULL;
PFNGLVERTEXATTRIB4USVARBPROC pglVertexAttrib4usvARB = NULL;
PFNGLVERTEXATTRIB4UIVARBPROC pglVertexAttrib4uivARB = NULL;

PFNGLVERTEXATTRIB4NBVARBPROC pglVertexAttrib4NbvARB = NULL;
PFNGLVERTEXATTRIB4NSVARBPROC pglVertexAttrib4NsvARB = NULL;
PFNGLVERTEXATTRIB4NIVARBPROC pglVertexAttrib4NivARB = NULL;
PFNGLVERTEXATTRIB4NUBVARBPROC pglVertexAttrib4NubvARB = NULL;
PFNGLVERTEXATTRIB4NUSVARBPROC pglVertexAttrib4NusvARB = NULL;
PFNGLVERTEXATTRIB4NUIVARBPROC pglVertexAttrib4NuivARB = NULL;


PFNGLDELETEOBJECTARBPROC pglDeleteObjectARB = NULL;
PFNGLGETHANDLEARBPROC pglGetHandleARB = NULL;
PFNGLDETACHOBJECTARBPROC pglDetachObjectARB = NULL;
PFNGLCREATESHADEROBJECTARBPROC pglCreateShaderObjectARB = NULL;
PFNGLSHADERSOURCEARBPROC pglShaderSourceARB = NULL;
PFNGLCOMPILESHADERARBPROC pglCompileShaderARB = NULL;
PFNGLCREATEPROGRAMOBJECTARBPROC pglCreateProgramObjectARB = NULL;
PFNGLATTACHOBJECTARBPROC pglAttachObjectARB = NULL;
PFNGLLINKPROGRAMARBPROC pglLinkProgramARB = NULL;
PFNGLUSEPROGRAMOBJECTARBPROC pglUseProgramObjectARB = NULL;
PFNGLVALIDATEPROGRAMARBPROC pglValidateProgramARB = NULL;

PFNGLUNIFORM1FARBPROC pglUniform1fARB = NULL;
PFNGLUNIFORM2FARBPROC pglUniform2fARB = NULL;
PFNGLUNIFORM3FARBPROC pglUniform3fARB = NULL;
PFNGLUNIFORM4FARBPROC pglUniform4fARB = NULL;
PFNGLUNIFORM1IARBPROC pglUniform1iARB = NULL;
PFNGLUNIFORM2IARBPROC pglUniform2iARB = NULL;
PFNGLUNIFORM3IARBPROC pglUniform3iARB = NULL;
PFNGLUNIFORM4IARBPROC pglUniform4iARB = NULL;
PFNGLUNIFORM1FVARBPROC pglUniform1fvARB = NULL;
PFNGLUNIFORM2FVARBPROC pglUniform2fvARB = NULL;
PFNGLUNIFORM3FVARBPROC pglUniform3fvARB = NULL;
PFNGLUNIFORM4FVARBPROC pglUniform4fvARB = NULL;
PFNGLUNIFORM1IVARBPROC pglUniform1ivARB = NULL;
PFNGLUNIFORM2IVARBPROC pglUniform2ivARB = NULL;
PFNGLUNIFORM3IVARBPROC pglUniform3ivARB = NULL;
PFNGLUNIFORM4IVARBPROC pglUniform4ivARB = NULL;

PFNGLUNIFORMMATRIX2FVARBPROC pglUniformMatrix2fvARB = NULL;
PFNGLUNIFORMMATRIX3FVARBPROC pglUniformMatrix3fvARB = NULL;
PFNGLUNIFORMMATRIX4FVARBPROC pglUniformMatrix4fvARB = NULL;

PFNGLGETOBJECTPARAMETERFVARBPROC pglGetObjectParameterfvARB = NULL;
PFNGLGETOBJECTPARAMETERIVARBPROC pglGetObjectParameterivARB = NULL;
PFNGLGETINFOLOGARBPROC pglGetInfoLogARB = NULL;
PFNGLGETATTACHEDOBJECTSARBPROC pglGetAttachedObjectsARB = NULL;
PFNGLGETUNIFORMLOCATIONARBPROC pglGetUniformLocationARB = NULL;
PFNGLGETACTIVEUNIFORMARBPROC pglGetActiveUniformARB = NULL;
PFNGLGETUNIFORMFVARBPROC pglGetUniformfvARB = NULL;
PFNGLGETUNIFORMIVARBPROC pglGetUniformivARB = NULL;
PFNGLGETSHADERSOURCEARBPROC pglGetShaderSourceARB = NULL;
 
/** pglobal function setting up the GLSL extension **/
bool glslSetupExtension()
{
	/** 1. step: check for extensions **/
	//extensions..
	const char *extensions = (char*)glGetString(GL_EXTENSIONS);
	
	//step by step procedure
	if (!strstr(extensions, "GL_ARB_shading_language_100"))
		return false;
	if (!strstr(extensions, "GL_ARB_shader_objects"))
		return false;
	if (!strstr(extensions, "GL_ARB_fragment_shader"))
		return false;
	if (!strstr(extensions, "GL_ARB_vertex_shader"))
		return false;
	
	//if we've come here, all extensions are supported
	
	/** 2. step: setup function pointers **/
	pglVertexAttrib1fARB = (PFNGLVERTEXATTRIB1FARBPROC)SGL_GETPROCADDRESS("glVertexAttrib1fARB");
	pglVertexAttrib1sARB = (PFNGLVERTEXATTRIB1SARBPROC)SGL_GETPROCADDRESS("glVertexAttrib1sARB");
	pglVertexAttrib1dARB = (PFNGLVERTEXATTRIB1DARBPROC)SGL_GETPROCADDRESS("glVertexAttrib1dARB");
	pglVertexAttrib2fARB = (PFNGLVERTEXATTRIB2FARBPROC)SGL_GETPROCADDRESS("glVertexAttrib2fARB");
	pglVertexAttrib2sARB = (PFNGLVERTEXATTRIB2SARBPROC)SGL_GETPROCADDRESS("glVertexAttrib2sARB");
	pglVertexAttrib2dARB = (PFNGLVERTEXATTRIB2DARBPROC)SGL_GETPROCADDRESS("glVertexAttrib2dARB");
	pglVertexAttrib3fARB = (PFNGLVERTEXATTRIB3FARBPROC)SGL_GETPROCADDRESS("glVertexAttrib3fARB");
	pglVertexAttrib3sARB = (PFNGLVERTEXATTRIB3SARBPROC)SGL_GETPROCADDRESS("glVertexAttrib3sARB");
	pglVertexAttrib3dARB = (PFNGLVERTEXATTRIB3FARBPROC)SGL_GETPROCADDRESS("glVertexAttrib3dARB");
	pglVertexAttrib4fARB = (PFNGLVERTEXATTRIB4FARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4fARB");
	pglVertexAttrib4sARB = (PFNGLVERTEXATTRIB4SARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4sARB");
	pglVertexAttrib4dARB = (PFNGLVERTEXATTRIB4DARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4dARB");
	pglVertexAttrib4NubARB = (PFNGLVERTEXATTRIB4NUBARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4NubARB");
	
	pglVertexAttrib1fvARB = (PFNGLVERTEXATTRIB1FVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib1fvARB");
	pglVertexAttrib1svARB = (PFNGLVERTEXATTRIB1SVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib1svARB");
	pglVertexAttrib1dvARB = (PFNGLVERTEXATTRIB1DVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib1dvARB");
	pglVertexAttrib2fvARB = (PFNGLVERTEXATTRIB2FVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib2fvARB");
	pglVertexAttrib2svARB = (PFNGLVERTEXATTRIB2SVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib2svARB");
	pglVertexAttrib2dvARB = (PFNGLVERTEXATTRIB2DVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib2dvARB");
	pglVertexAttrib3fvARB = (PFNGLVERTEXATTRIB3FVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib3fvARB");
	pglVertexAttrib3svARB = (PFNGLVERTEXATTRIB3SVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib3svARB");
	pglVertexAttrib3dvARB = (PFNGLVERTEXATTRIB3DVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib3dvARB");
	pglVertexAttrib4fvARB = (PFNGLVERTEXATTRIB4FVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4fvARB");
	pglVertexAttrib4svARB = (PFNGLVERTEXATTRIB4SVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4svARB");
	pglVertexAttrib4dvARB = (PFNGLVERTEXATTRIB4DVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4dvARB");
	pglVertexAttrib4ivARB = (PFNGLVERTEXATTRIB4IVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4ivARB");
	pglVertexAttrib4bvARB = (PFNGLVERTEXATTRIB4BVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4bvARB");
	pglVertexAttrib4ubvARB = (PFNGLVERTEXATTRIB4UBVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4ubvARB");
	pglVertexAttrib4usvARB = (PFNGLVERTEXATTRIB4USVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4usvARB");
	pglVertexAttrib4uivARB = (PFNGLVERTEXATTRIB4UIVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4uivARB");
	
	pglVertexAttrib4NbvARB = (PFNGLVERTEXATTRIB4NBVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4NbvARB");
	pglVertexAttrib4NsvARB = (PFNGLVERTEXATTRIB4NSVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4NsvARB");
	pglVertexAttrib4NivARB = (PFNGLVERTEXATTRIB4NIVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4NivARB");
	pglVertexAttrib4NubvARB = (PFNGLVERTEXATTRIB4NUBVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4NubvARB");
	pglVertexAttrib4NusvARB = (PFNGLVERTEXATTRIB4NUSVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4NusvARB");
	pglVertexAttrib4NuivARB = (PFNGLVERTEXATTRIB4NUIVARBPROC)SGL_GETPROCADDRESS("glVertexAttrib4NuivARB");
	
	pglDeleteObjectARB = (PFNGLDELETEOBJECTARBPROC)SGL_GETPROCADDRESS("glDeleteObjectARB");
	pglGetHandleARB = (PFNGLGETHANDLEARBPROC)SGL_GETPROCADDRESS("glGetHandleARB");
	pglDetachObjectARB = (PFNGLDETACHOBJECTARBPROC)SGL_GETPROCADDRESS("glDetachObjectARB");
	pglCreateShaderObjectARB = (PFNGLCREATESHADEROBJECTARBPROC)SGL_GETPROCADDRESS("glCreateShaderObjectARB");
	pglShaderSourceARB = (PFNGLSHADERSOURCEARBPROC)SGL_GETPROCADDRESS("glShaderSourceARB");
	pglCompileShaderARB = (PFNGLCOMPILESHADERARBPROC)SGL_GETPROCADDRESS("glCompileShaderARB");
	pglCreateProgramObjectARB = (PFNGLCREATEPROGRAMOBJECTARBPROC)SGL_GETPROCADDRESS("glCreateProgramObjectARB");
	pglAttachObjectARB = (PFNGLATTACHOBJECTARBPROC)SGL_GETPROCADDRESS("glAttachObjectARB");
	pglLinkProgramARB = (PFNGLLINKPROGRAMARBPROC)SGL_GETPROCADDRESS("glLinkProgramARB");
	pglUseProgramObjectARB = (PFNGLUSEPROGRAMOBJECTARBPROC)SGL_GETPROCADDRESS("glUseProgramObjectARB");
	pglValidateProgramARB = (PFNGLVALIDATEPROGRAMARBPROC)SGL_GETPROCADDRESS("glValidateProgramARB");
	
	pglUniform1fARB = (PFNGLUNIFORM1FARBPROC)SGL_GETPROCADDRESS("glUniform1fARB");
	pglUniform2fARB = (PFNGLUNIFORM2FARBPROC)SGL_GETPROCADDRESS("glUniform2fARB");
	pglUniform3fARB = (PFNGLUNIFORM3FARBPROC)SGL_GETPROCADDRESS("glUniform3fARB");
	pglUniform4fARB = (PFNGLUNIFORM4FARBPROC)SGL_GETPROCADDRESS("glUniform4fARB");
	pglUniform1iARB = (PFNGLUNIFORM1IARBPROC)SGL_GETPROCADDRESS("glUniform1iARB");
	pglUniform2iARB = (PFNGLUNIFORM2IARBPROC)SGL_GETPROCADDRESS("glUniform2iARB");
	pglUniform3iARB = (PFNGLUNIFORM3IARBPROC)SGL_GETPROCADDRESS("glUniform3iARB");
	pglUniform4iARB = (PFNGLUNIFORM4IARBPROC)SGL_GETPROCADDRESS("glUniform4iARB");
	pglUniform1fvARB = (PFNGLUNIFORM1FVARBPROC)SGL_GETPROCADDRESS("glUniform1fvARB");
	pglUniform2fvARB = (PFNGLUNIFORM2FVARBPROC)SGL_GETPROCADDRESS("glUniform2fvARB");
	pglUniform3fvARB = (PFNGLUNIFORM3FVARBPROC)SGL_GETPROCADDRESS("glUniform3fvARB");
	pglUniform4fvARB = (PFNGLUNIFORM4FVARBPROC)SGL_GETPROCADDRESS("glUniform4fvARB");
	pglUniform1ivARB = (PFNGLUNIFORM1IVARBPROC)SGL_GETPROCADDRESS("glUniform1ivARB");
	pglUniform2ivARB = (PFNGLUNIFORM2IVARBPROC)SGL_GETPROCADDRESS("glUniform2ivARB");
	pglUniform3ivARB = (PFNGLUNIFORM3IVARBPROC)SGL_GETPROCADDRESS("glUniform3ivARB");
	pglUniform4ivARB = (PFNGLUNIFORM4IVARBPROC)SGL_GETPROCADDRESS("glUniform4ivARB");
	
	pglUniformMatrix2fvARB = (PFNGLUNIFORMMATRIX2FVARBPROC)SGL_GETPROCADDRESS("glUniformMatrix2fvARB");
	pglUniformMatrix3fvARB = (PFNGLUNIFORMMATRIX3FVARBPROC)SGL_GETPROCADDRESS("glUniformMatrix3fvARB");
	pglUniformMatrix4fvARB = (PFNGLUNIFORMMATRIX4FVARBPROC)SGL_GETPROCADDRESS("glUniformMatrix4fvARB");
	
	pglGetObjectParameterfvARB = (PFNGLGETOBJECTPARAMETERFVARBPROC)SGL_GETPROCADDRESS("glGetObjectParameterfvARB");
	pglGetObjectParameterivARB = (PFNGLGETOBJECTPARAMETERIVARBPROC)SGL_GETPROCADDRESS("glGetObjectParameterivARB");
	pglGetInfoLogARB = (PFNGLGETINFOLOGARBPROC)SGL_GETPROCADDRESS("glGetInfoLogARB");
	pglGetAttachedObjectsARB = (PFNGLGETATTACHEDOBJECTSARBPROC)SGL_GETPROCADDRESS("glGetAttachedObjectsARB");
	pglGetUniformLocationARB = (PFNGLGETUNIFORMLOCATIONARBPROC)SGL_GETPROCADDRESS("glGetUniformLocationARB");
	pglGetActiveUniformARB = (PFNGLGETACTIVEUNIFORMARBPROC)SGL_GETPROCADDRESS("glGetActiveUniformARB");
	pglGetUniformfvARB = (PFNGLGETUNIFORMFVARBPROC)SGL_GETPROCADDRESS("glGetUniformfvARB");
	pglGetUniformivARB = (PFNGLGETUNIFORMIVARBPROC)SGL_GETPROCADDRESS("glGetUniformivARB");
	pglGetShaderSourceARB = (PFNGLGETSHADERSOURCEARBPROC)SGL_GETPROCADDRESS("glGetShaderSourceARB");
	
	//everything done..
	return true;
}
